// main.c
// projet : imaguce.
// Cr le 09 sept 2008 par Anat.

#include <stdio.h>
#include <stdlib.h>
#include "parser/iniparser.h"

// ------------------------------------------------------------------
// Dfinitions
// ------------------------------------------------------------------
#define CONFIG_FILE "imaguce.ini"
#define DEF_OUTPUT_DIR imaguce-output
#define DEF_QUALITY 80
#define DEF_SIZE    800
// ------------------------------------------------------------------
// Global variables
// ------------------------------------------------------------------
int quality = 80;  // Qualit par dfaut souhaite pour la compression
                   // JPEG (0 : qualit minimale, 100 : Best qualit)
int size    = 800; // Largeur par dfaut de l'image  crer

// ------------------------------------------------------------------
// Functions
// ------------------------------------------------------------------

// Extraction des paramtres du fichier de config
int parse_ini_file(char * ini_name)
{
	dictionary * ini ;

	/* Some temporary variables to hold query results */
	int	i ;

	ini = iniparser_load(ini_name);
	if (ini==NULL) {
		fprintf(stderr, "cannot parse file: %s\n", ini_name);
		return -1 ;
	}
	//iniparser_dump(ini, stderr);

	/* Get global attributes */
	i = iniparser_getint(ini, "global:quality", -1);
	if (i > 0)
		quality = i;

	i = iniparser_getint(ini, "global:size", -1);
	if (i > 0)
		size = i;

	iniparser_freedict(ini);
	return 0 ;
}


// ------------------------------------------------------------------
// MAIN
// ------------------------------------------------------------------
int main(int argc, char *argv[])
{
  // Dclarations
  // ------------
  unsigned int status;
  int k = 0;
  FILE * fp;
  
  // Initialisations
  // ---------------
  
  // Test d'existence du fichier de config
  fp = fopen(CONFIG_FILE, "r");
  if (fp == NULL)
  {
      /* fichier inexistant, on le cre si possible */
      fp = fopen(CONFIG_FILE, "wt");
      if (fp != NULL)
      {
        fprintf (fp,"# Fichier de config de imaguce\n\
# Cr le 08 oct 2008, par Anat.\n\
# Saisissez dans ce fichier les paramtres pour les images modifies.\n\n\
[global]\n\n\
quality = 80 ; Qualit souhaite (0:Trs compress, 100:Haute qualit)\n\
size = 800 ; Largeur souhaite\n") ;
        fclose(fp);
      }
      /* On charge les valeurs par dfaut en RAM*/
      quality = DEF_QUALITY ;
      size    = DEF_SIZE ;
  }
  else
  {
    /* fichier existant, on le parse */
    fclose(fp); /* Il sera rouvert par parse_ini_file()*/
    status = parse_ini_file(CONFIG_FILE);
  }
  
  // Dbut
  // -----  
  while (++k < argc)
  {
  		// A complter : Insrer ici la commande
  		// convert (argv[k],DEF_OUTPUT_DIR/image_k.jpg, size, quality)
  		
  		// Pour l'instant, j'affiche juste en console la liste des images
  		// prsentes en argument (Ca fonctionne) :
        printf("Arg %d : %s\n", k, argv[k]);
  }
  
  printf("quality : %d, size : %d\n", quality, size);
  system("PAUSE");	
  return 0;
}
